Index: conf/i386-pc.rmk
===================================================================
RCS file: /cvsroot/grub/grub2/conf/i386-pc.rmk,v
retrieving revision 1.25
diff -u -p -r1.25 i386-pc.rmk
--- conf/i386-pc.rmk	31 Jan 2005 21:40:25 -0000	1.25
+++ conf/i386-pc.rmk	7 Feb 2005 18:54:54 -0000
@@ -61,7 +61,7 @@ grub_mkimage_LDFLAGS = -llzo
 grub_setup_SOURCES = util/i386/pc/grub-setup.c util/i386/pc/biosdisk.c \
 	util/misc.c util/i386/pc/getroot.c kern/device.c kern/disk.c \
 	kern/err.c kern/misc.c fs/fat.c fs/ext2.c \
-	kern/partition.c partmap/amiga.c partmap/apple.c partmap/pc.c \
+	kern/partition.c partmap/amiga.c partmap/apple.c partmap/pc.c partmap/sun.c \
 	fs/ufs.c fs/minix.c fs/hfs.c fs/jfs.c kern/file.c kern/fs.c kern/env.c fs/fshelp.c
 
 # For grub
@@ -69,7 +69,7 @@ grub_emu_SOURCES = kern/main.c kern/devi
 	kern/disk.c kern/dl.c kern/file.c kern/fs.c kern/err.c		\
         kern/misc.c kern/loader.c kern/rescue.c kern/term.c		\
 	kern/partition.c kern/env.c commands/ls.c partmap/amiga.c	\
-	partmap/pc.c partmap/apple.c					\
+	partmap/pc.c partmap/apple.c partmap/sun.c			\
 	commands/terminal.c commands/boot.c commands/cmp.c commands/cat.c		\
 	util/i386/pc/biosdisk.c fs/fat.c fs/ext2.c fs/ufs.c fs/minix.c fs/hfs.c fs/jfs.c fs/iso9660.c \
 	normal/cmdline.c normal/command.c normal/main.c normal/menu.c normal/arg.c	\
@@ -84,7 +84,7 @@ genmoddep_SOURCES = util/genmoddep.c
 pkgdata_MODULES = _chain.mod _linux.mod linux.mod fat.mod ufs.mod ext2.mod minix.mod \
 	hfs.mod jfs.mod normal.mod hello.mod vga.mod font.mod _multiboot.mod ls.mod \
 	boot.mod cmp.mod cat.mod terminal.mod fshelp.mod chain.mod multiboot.mod \
-	amiga.mod apple.mod pc.mod loopback.mod reboot.mod halt.mod help.mod
+	amiga.mod apple.mod pc.mod sun.mod loopback.mod reboot.mod halt.mod help.mod
 
 # For _chain.mod.
 _chain_mod_SOURCES = loader/i386/pc/chainloader.c
@@ -204,6 +204,10 @@ apple_mod_CFLAGS = $(COMMON_CFLAGS)
 pc_mod_SOURCES = partmap/pc.c
 pc_mod_CFLAGS = $(COMMON_CFLAGS)
 
+# For sun.mod
+sun_mod_SOURCES = partmap/sun.c
+sun_mod_CFLAGS = $(COMMON_CFLAGS)
+
 # For loopback.mod
 loopback_mod_SOURCES = disk/loopback.c
 loopback_mod_CFLAGS = $(COMMON_CFLAGS)
Index: include/grub/partition.h
===================================================================
RCS file: /cvsroot/grub/grub2/include/grub/partition.h,v
retrieving revision 1.1
diff -u -p -r1.1 partition.h
--- include/grub/partition.h	4 Dec 2004 18:45:45 -0000	1.1
+++ include/grub/partition.h	7 Feb 2005 18:54:55 -0000
@@ -89,6 +89,10 @@ void grub_amiga_partition_map_init (void
 void grub_amiga_partition_map_fini (void);
 void grub_apple_partition_map_init (void);
 void grub_apple_partition_map_fini (void);
+void grub_sun_partition_map_init (void);
+void grub_sun_partition_map_fini (void);
 #endif
 
 static inline unsigned long
Index: partmap/sun.c
===================================================================
RCS file: partmap/sun.c
diff -N partmap/sun.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ partmap/sun.c	7 Feb 2005 18:54:59 -0000
@@ -0,0 +1,216 @@
+/* sun.c - Read SUN style partition tables.  */
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2002, 2005 Free Software Foundation, Inc.
+ *
+ *  GRUB is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB; if not, write to the Free Software
+ *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+
+#include <grub/partition.h>
+#include <grub/disk.h>
+#include <grub/mm.h>
+#include <grub/misc.h>
+#include <grub/dl.h>
+
+#include <grub/symbol.h>
+#include <grub/types.h>
+#include <grub/err.h>
+
+#define GRUB_PARTMAP_SUN_MAGIC 0xDABE
+#define GRUB_PARTMAP_SUN_MAX_PARTS 8
+#define GRUB_PARTMAP_SUN_WHOLE_DISK_ID 0x05
+
+
+struct grub_sun_partition_info
+{
+  grub_uint8_t spare1;
+  grub_uint8_t id;
+  grub_uint8_t spare2;
+  grub_uint8_t flags;
+} __attribute__ ((packed));
+
+struct grub_sun_partition_descriptor
+{
+  grub_uint32_t start_cylinder;
+  grub_uint32_t num_sectors;
+} __attribute__ ((packed));
+
+struct grub_sun_block
+{
+  grub_uint8_t  info[128];      /* Informative text string.  */
+  grub_uint8_t  spare0[14];
+  struct grub_sun_partition_info infos[8];
+  grub_uint8_t  spare1[246];    /* Boot information etc.  */
+  grub_uint16_t  rspeed;        /* Disk rotational speed.  */
+  grub_uint16_t  pcylcount;     /* Physical cylinder count.  */
+  grub_uint16_t  sparecyl;      /* extra sects per cylinder.  */
+  grub_uint8_t  spare2[4];      /* More magic...  */
+  grub_uint16_t  ilfact;        /* Interleave factor.  */
+  grub_uint16_t  ncyl;          /* Data cylinder count.  */
+  grub_uint16_t  nacyl;         /* Alt. cylinder count.  */
+  grub_uint16_t  ntrks;         /* Tracks per cylinder.  */
+  grub_uint16_t  nsect;         /* Sectors per track.  */
+  grub_uint8_t  spare3[4];      /* Even more magic...  */
+  struct grub_sun_partition_descriptor partitions[8];
+  grub_uint16_t  magic;         /* Magic number.  */
+  grub_uint16_t  csum;          /* Label xor'd checksum.  */
+} __attribute__ ((packed));
+
+static struct grub_partition_map grub_sun_partition_map;
+
+#ifndef GRUB_UTIL
+static grub_dl_t my_mod;
+#endif
+
+/* Verify checksum (true=ok).  */
+static int
+grub_sun_is_valid (struct grub_sun_block *label)
+{
+  grub_uint16_t *pos;
+  grub_uint16_t sum = 0;
+  for (pos = (grub_uint16_t *) label; pos < (grub_uint16_t *) (label + 1); pos++)
+    sum ^= *pos;
+  return !sum;
+}
+
+static grub_err_t
+sun_partition_map_iterate (grub_disk_t disk,
+                           int (*hook) (const grub_partition_t partition))
+{
+  struct grub_partition *p;
+  struct grub_disk raw;
+  struct grub_sun_block block;
+  int partnum;
+  raw = *disk;
+  raw.partition = 0;
+  p = (struct grub_partition *) grub_malloc (sizeof (struct grub_partition));
+  if (p)
+    {
+      p->offset = 0;
+      p->data = 0;
+      p->partmap = &grub_sun_partition_map;
+      if (grub_disk_read (&raw, 0, 0, sizeof (struct grub_sun_block),
+                          (char *) &block) == GRUB_ERR_NONE)
+        {
+          if (GRUB_PARTMAP_SUN_MAGIC != grub_be_to_cpu16 (block.magic))
+            grub_error (GRUB_ERR_BAD_PART_TABLE, "not a sun partiton table");
+          if (!grub_sun_is_valid (&block))
+            grub_error (GRUB_ERR_BAD_PART_TABLE, "invalid checksum");
+          /* Maybe another error value would be better, because
+           * partition table _is_ recognised but invalid.  */
+          for (partnum = 0; partnum < GRUB_PARTMAP_SUN_MAX_PARTS; partnum++)
+            {
+              if (block.infos[partnum].id == 0 ||
+                  block.infos[partnum].id == GRUB_PARTMAP_SUN_WHOLE_DISK_ID)
+                continue;
+              p->start = grub_be_to_cpu32
+                           (block.partitions[partnum].start_cylinder)
+                           * grub_be_to_cpu16 (block.ntrks)
+                           * grub_be_to_cpu16 (block.nsect);
+              p->len = grub_be_to_cpu32 (block.partitions[partnum].num_sectors);
+              p->index = partnum;
+              if (p->len)
+                {
+                  if (hook (p))
+                    partnum = GRUB_PARTMAP_SUN_MAX_PARTS;
+                }
+            }
+        }
+      grub_free (p);
+    }
+  return grub_errno;
+}
+
+static grub_partition_t
+sun_partition_map_probe (grub_disk_t disk, const char *str)
+{
+  grub_partition_t p = 0;
+  int partnum = 0;
+  char *s = (char *) str;
+
+  auto int find_func (const grub_partition_t partition);
+  int find_func (const grub_partition_t partition)
+    {
+      if (partnum == partition->index)
+        {
+          p = (grub_partition_t) grub_malloc (sizeof (*p));
+          if (p)
+            grub_memcpy(p, partition, sizeof (*p));
+          return 1;
+        }
+      return 0;
+    }
+
+  grub_errno = GRUB_ERR_NONE;
+  partnum = grub_strtoul (s, 0, 10);
+  if (grub_errno == GRUB_ERR_NONE)
+    {
+      if (sun_partition_map_iterate (disk, find_func))
+        {
+          grub_free (p);
+          p = 0;
+        }
+    }
+  else
+    {
+      grub_error (GRUB_ERR_BAD_FILENAME, "invalid partition");
+      p = 0;
+    }
+  return p;
+}
+
+static char *
+sun_partition_map_get_name (const grub_partition_t p)
+{
+  char *name;
+  name = grub_malloc (13);
+  if (name)
+    grub_sprintf (name, "%d", p->index);
+  return name;
+}
+
+/* Partition map type.  */
+static struct grub_partition_map grub_sun_partition_map =
+  {
+    .name = "sun_partition_map",
+    .iterate = sun_partition_map_iterate,
+    .probe = sun_partition_map_probe,
+    .get_name = sun_partition_map_get_name
+  };
+
+#ifdef GRUB_UTIL
+void
+grub_sun_partition_map_init (void)
+{
+  grub_partition_map_register (&grub_sun_partition_map);
+}
+
+void
+grub_sun_partition_map_fini (void)
+{
+  grub_partition_map_unregister (&grub_sun_partition_map);
+}
+#else
+GRUB_MOD_INIT
+{
+  grub_partition_map_register (&grub_sun_partition_map);
+  my_mod = mod;
+}
+
+GRUB_MOD_FINI
+{
+  grub_partition_map_unregister (&grub_sun_partition_map);
+}
+#endif
Index: util/grub-emu.c
===================================================================
RCS file: /cvsroot/grub/grub2/util/grub-emu.c,v
retrieving revision 1.13
diff -u -p -r1.13 grub-emu.c
--- util/grub-emu.c	31 Jan 2005 21:40:25 -0000	1.13
+++ util/grub-emu.c	7 Feb 2005 18:54:59 -0000
@@ -160,6 +160,7 @@ main (int argc, char *argv[])
   /* XXX: This is a bit unportable.  */
   grub_util_biosdisk_init (args.dev_map);
   grub_pc_partition_map_init ();
+  grub_sun_partition_map_init ();
   grub_amiga_partition_map_init ();
   grub_apple_partition_map_init ();
 
@@ -200,6 +201,7 @@ main (int argc, char *argv[])
   grub_cat_fini ();
   grub_terminal_fini ();
   grub_amiga_partition_map_fini ();
+  grub_sun_partition_map_fini ();
   grub_pc_partition_map_fini ();
   grub_apple_partition_map_fini ();
   
